﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RealTimeStereoTestViewer
{
    /// <summary>
    /// A base interface for a single parameter control, which allows the contents to be updated
    /// when the underlying parameter value is thought to have changed
    /// </summary>
    interface IParameterControl
    {
        /// <summary>
        /// Indicates that the control should be updated to reflect a non-UI change in the underlying
        /// parameter
        /// </summary>
        void RefreshValue();
    }
}
